﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ohjaus1_forms
{
    public partial class laskuri : Form
    {
        private int l_autot = 0;
        private int l_pyorat = 0;
        public int autot
        {

            get { return l_autot; }
            set { l_autot += lkm(); tallennettu = false; }

        }
        public int pyorat
        {

            get { return l_pyorat; }
            set { l_pyorat += lkm(); tallennettu = false; }

        }

        private bool tallennettu = true;

        public laskuri()
        {
            InitializeComponent();
            Liikkuva auto = new Liikkuva();
            Liikkuva pyora = new Liikkuva();
            Controls.Add(auto);
            Controls.Add(pyora);
            pyora.Image = global::ohjaus1_forms.Properties.Resources.bike;
            auto.Image = global::ohjaus1_forms.Properties.Resources.car;
        }

        private int lkm()
        {

            int lkm = 1;
            try
            {
                lkm = Convert.ToInt16(textBoxLkm.Text);
            }
            catch (Exception)
            {
                lkm = 1;
            }
            return lkm;

        }

        private void buttonAuto_Click(object sender, EventArgs e)
        {
            autot++;
            labelAuto.Text = autot.ToString();
        }

        private void buttonPyora_Click(object sender, EventArgs e)
        {
            pyorat++;
            labelPyora.Text = pyorat.ToString();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            about ab = new about();
            ab.ShowDialog();
        }

        private void väritToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ColorDialog dlg = new ColorDialog();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                labelAuto.BackColor = dlg.Color;
                labelPyora.BackColor = dlg.Color;

            }

        }

        private void buttonUusi_Click(object sender, EventArgs e)
        {
            laskuri l = new laskuri();
            l.Show();
        }

        private void tallennaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog dlg = new SaveFileDialog();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                System.IO.TextWriter tw = new System.IO.StreamWriter(dlg.FileName);
                tw.WriteLine("Autoja: " + labelAuto.Text);
                tw.WriteLine("Polkupyöriä: " + labelPyora.Text);
                tw.Close();
                tallennettu = true;
            }

        }

        private void laskuri_FormClosing(object sender, FormClosingEventArgs e)
        {
            /*
            if ( tallennettu == false) 
                if ( MessageBox.Show("Et ole tallentanut. Haluatko varmasti lopettaa?", "Laskuri", MessageBoxButtons.YesNo) == DialogResult.No )
                    e.Cancel = true;
            */
            if (tallennettu == false)
            {
                DialogResult p = MessageBox.Show("Et ole tallentanut. Haluatko tallentaa ennen lopettamista?", "Laskuri", MessageBoxButtons.YesNoCancel);
                if (p == DialogResult.Yes)
                {
                    tallennaToolStripMenuItem_Click(sender, e);
                    if (tallennettu == false) e.Cancel = true; //jos tallennus menee pieleen ei kuitenkaan lopeteta 
                }
                if (p == DialogResult.Cancel) e.Cancel = true;
            }
        }
    }
        public class Liikkuva : PictureBox
        {
            private int nopeus = 10;
            private System.Windows.Forms.Timer ajastin = new System.Windows.Forms.Timer();

            public Liikkuva()
            {
                this.ParentChanged += new System.EventHandler(this.OnParentChanged);
                this.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
                this.TabStop = false;

                ajastin.Tick += new System.EventHandler(this.ajastin_Tick);
            }
            // parentiin eli tässä tapauksessa lomakkeeseen voidaan viitata vasta, kun kontrolli on lisätty lomakkeelle
            // eli ei vielä suoraan konstruktorissa vaan esim. ParentChanged-tapahtuman jälkeen
            private void OnParentChanged(object sender, EventArgs e)
            {
                // varmistetaan, että parent ei ole null!
                if (Parent == null)
                {
                    ajastin.Enabled = false;
                }
                else
                {
                    ajastin.Enabled = true;
                    Random r = new Random();
                    this.Location = new System.Drawing.Point(r.Next(0, Parent.ClientSize.Width - ClientSize.Width), r.Next(0, Parent.ClientSize.Height - ClientSize.Height));
                }
            }

            private void ajastin_Tick(object sender, EventArgs e)
            {

                if (Left <= 0) nopeus = -nopeus;
                // varmistus, että parent on kelvollinen
                if (Parent != null && Right >= Parent.ClientSize.Width) nopeus = -nopeus;
                Left = Left + nopeus;
            }


        }
}
